Attribute VB_Name = "modBackUpToTExt"
Option Compare Database
Option Explicit


Dim Path As String
Dim DateTimeString As String
Dim App As Access.Application
Private Sub SaveMDBObjectsAsText()
Dim r As Reference
DateTimeString = Format(Now(), "yyyymmddhhnn")
Path = CurrentProject.Path & "\AS_TEXT_" & DateTimeString & "\"
MkDir Path
Set App = New Access.Application
'SaveDataAccessPagesAsText
SaveFormsAsText
SaveReportsAsText
SaveModulesAsText
SaveQueriesAsText
SaveMDBBase
'LoadDataAccessPagesFromText
LoadFormsFromText
LoadReportsFromText
LoadModulesFromText
LoadQueriesFromText
On Error Resume Next  'VLAD -YOU NEED TO COMMENT THIS OUT TO SEE THE ERRORS
With App
With .CurrentProject
' disable special keys
' With .Properties
' .Add "AllowByPassKey", False
' .Item("AllowByPassKey").Value = False
' .Add "AllowSpecialKeys", False
' .Item("AllowSpecialKeys").Value = False
' End With
Path = .FullName
End With

For Each r In .References
With r
If Not .BuiltIn Then
App.References.Remove r
End If
End With
Next r

For Each r In References
With r
If Not .BuiltIn Then
App.References.AddFromGuid r.Guid, r.Major, r.Minor
End If
End With
Next r

.RunCommand acCmdCompileAndSaveAllModules
.CloseCurrentDatabase
' convert to AC2k
'.ConvertAccessProject Path, Replace(Path, "XP.", "."), acFileFormatAccess2000
' make mde
' .SysCmd 603, Path, Replace(Path, ".mdb", ".mde")
.Quit
End With
Set App = Nothing
MsgBox "All Done with Text Backup"
End Sub

Private Sub SaveDataAccessPagesAsText()
Dim FileName As String
Dim Name As String
Dim DataAccessPage As AccessObject
For Each DataAccessPage In CurrentProject.AllDataAccessPages
Name = DataAccessPage.Name
FileName = Path & Name & ".txt"
SaveAsText acDataAccessPage, Name, FileName
Next DataAccessPage
End Sub

Private Sub SaveFormsAsText()
Dim FileName As String
Dim Name As String
Dim Form As AccessObject
For Each Form In CurrentProject.AllForms
Name = Form.Name
FileName = Path & Name & ".txt"
SaveAsText acForm, Name, FileName
Next Form
End Sub

Private Sub SaveReportsAsText()
Dim FileName As String
Dim Name As String
Dim Report As AccessObject
For Each Report In CurrentProject.AllReports
Name = Report.Name
FileName = Path & Name & ".txt"
SaveAsText acReport, Name, FileName
Next Report
End Sub

Private Sub SaveModulesAsText()
Dim FileName As String
Dim Name As String
Dim Module As AccessObject
For Each Module In CurrentProject.AllModules
Name = Module.Name
FileName = Path & Name & ".txt"
SaveAsText acModule, Name, FileName
Next Module
End Sub

Private Sub SaveQueriesAsText()
Dim FileName As String
Dim Name As String
Dim qdf As DAO.QueryDef


For Each qdf In CurrentDb.QueryDefs
    Name = qdf.Name
    If Left(Name, 3) <> "~sq" Then
        FileName = Path & Name & ".txt"
        SaveAsText acQuery, Name, FileName
    End If
Next qdf
End Sub

Private Sub SaveMDBBase()
Dim FileName As String
Dim Name As String
Name = Replace(CurrentProject.Name, CurrentProject.Path, "")
' name it with XP sffix to enable later conversion to 2K
Name = Replace(Name, ".", "XP.")
FileName = Path & Name
SaveAsText 6, "", FileName
App.OpenCurrentDatabase FileName
End Sub

Private Sub LoadDataAccessPagesFromText()
Dim FileName As String
Dim Name As String
Dim DataAccessPage As AccessObject
For Each DataAccessPage In CurrentProject.AllDataAccessPages
Name = DataAccessPage.Name
FileName = Path & Name '& ".txt"
App.LoadFromText acDataAccessPage, Name, FileName
Next DataAccessPage
End Sub

Private Sub LoadFormsFromText()
On Error Resume Next
Dim FileName As String
Dim Name As String
Dim Form As AccessObject
For Each Form In CurrentProject.AllForms
Name = Form.Name
FileName = Path & Name & ".txt"
App.LoadFromText acForm, Name, FileName
Next Form
End Sub

Private Sub LoadReportsFromText()
Dim FileName As String
Dim Name As String
Dim Report As AccessObject
For Each Report In CurrentProject.AllReports
Name = Report.Name
FileName = Path & Name & ".txt"
App.LoadFromText acReport, Name, FileName
Next Report
End Sub

Private Sub LoadModulesFromText()
Dim FileName As String
Dim Name As String
Dim Module As AccessObject
For Each Module In CurrentProject.AllModules
Name = Module.Name
FileName = Path & Name & ".txt"
App.LoadFromText acModule, Name, FileName
Next Module
End Sub

Private Sub LoadQueriesFromText()
Dim FileName As String
Dim Name As String

Dim qdf As DAO.QueryDef


For Each qdf In CurrentDb.QueryDefs
    Name = qdf.Name
    If Left(Name, 3) <> "~sq" Then
        FileName = Path & Name & ".txt"
        App.LoadFromText acQuery, Name, FileName
    End If
Next qdf


End Sub
